local kirbvalid = 0

rawset(_G, "K_Dropdash", function(checkflags, destroy, late, player)
	if (checkflags)
		if (player.kvars.ablstate)
		or (player.kvars.ablvar1)
			return AF_NOFLOAT|AF_NODUCK|AF_NOSWIM|AF_NODROP
		end
		return 0
	end
	if (destroy)
		return
	end
	if (late)
		return
	end
	if player.spintics == 1
	and not (player.kvars.ablvar1)
	and not (player.kvars.floating)
	and not (player.pflags & PF_SLIDING)
	and not (player.powers[pw_carry])
	and not (player.exiting)
	and not (player.pflags & PF_STASIS)
	and not (player.powers[pw_nocontrol])
	and not (player.kvars.industdevil)
	and not P_IsPlayerOnGround(player)
	and not P_PlayerInPain(player)
		if not player.kvars.ablstate
			player.kvars.ablvar1 = 2
			S_StartSound(player.mo, sfx_dpds)
			if (player.pflags & PF_SPINNING)
				player.pflags = $ & ~PF_SPINNING
			end
		end
	end
	if player.kvars.ablvar1
		if P_PlayerInPain(player)
		or player.powers[pw_carry]
		or (player.mo.eflags & MFE_SPRUNG)
		or not (player.cmd.buttons & BT_SPIN)
			player.kvars.ablvar1 = 0
			player.pflags = $|PF_NOJUMPDAMAGE
			return
		end
		player.kvars.ablvar1 = $ + 1
		local ghost = SpawnGhost(player)
		ghost.fuse = 3
		ghost.blendmode = AST_ADD
		ghost.frame = $ & ~(FF_TRANSMASK) | FF_TRANS50
		P_SetOrigin(ghost, player.mo.x, player.mo.y, player.mo.z)
		ghost.momx = 3*player.mo.momx/4
		ghost.momy = 3*player.mo.momy/4
		ghost.momz = 3*player.mo.momz/4
		ghost.dispoffset = 4
		local ghost2 = SpawnGhost(player)
		ghost2.fuse = 3
		ghost2.scale = $ + ($/5)
		ghost2.frame = $ & ~(FF_TRANSMASK) | FF_TRANS80
		P_SetOrigin(ghost2, player.mo.x, player.mo.y, player.mo.z - (player.mo.height/10))
		ghost2.momx = 3*player.mo.momx/4
		ghost2.momy = 3*player.mo.momy/4
		ghost2.momz = 3*player.mo.momz/4
		ghost2.dispoffset = 5
		if player.mo.state ~= S_PLAY_ROLL
			player.mo.state = S_PLAY_ROLL
		end
		player.pflags = $ & ~PF_NOJUMPDAMAGE
		if P_IsPlayerOnGround(player)
			player.kvars.ablvar1 = 0
			if not player.powers[pw_sneakers]
				if not player.powers[pw_underwater]
					if not player.powers[pw_super]
						P_InstaThrust(player.mo, player.drawangle, ((skins[player.mo.skin].normalspeed + 15*FRACUNIT)))
					else
						P_InstaThrust(player.mo, player.drawangle, ((skins[player.mo.skin].normalspeed + 25*FRACUNIT)))
					end
				else
					if not player.powers[pw_super]
						P_InstaThrust(player.mo, player.drawangle, (((skins[player.mo.skin].normalspeed/2) + 5*FRACUNIT)))
					else
						P_InstaThrust(player.mo, player.drawangle, (((skins[player.mo.skin].normalspeed/2) + 15*FRACUNIT)))
					end
				end
			else
				if not player.powers[pw_underwater]
					P_InstaThrust(player.mo, player.drawangle, ((skins[player.mo.skin].normalspeed + 25*FRACUNIT)))
				else
					P_InstaThrust(player.mo, player.drawangle, (((skins[player.mo.skin].normalspeed/2) + 15*FRACUNIT)))
				end
			end
			S_StartSound(player.mo, sfx_zoom)
			player.pflags = $|PF_SPINNING|PF_NOJUMPDAMAGE
			player.mo.state = S_PLAY_ROLL
			coollookindust(player)
		end
	end
end)

addHook("ThinkFrame", function()
	if skins["kirby"]
		kirbvalid = $ + 1
	end
	if kirbvalid == 1
		local addednum = K_AddAbility(K_Dropdash, false, "DROP")
		kirbyabilitytable["sonic"] = addednum
	end
end)